config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, controllers: { sessions: 'sessions' }
  namespace :admin do
    root to: 'dashboard#index'

    resources :static_pages
    resources :reviews
    resources :users
    resources :portfolios
    resources :videos
    resources :articles
    resources :subcategories
    resources :categories
    resources :vendors
  end

  mount API::Base, at: '/'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/vendor.rb
class Vendor < ApplicationRecord
  belongs_to :category, required: false
  belongs_to :subcategory, required: false
  has_many :portfolios
  has_many :reviews

  validates :title, presence: true, length: { maximum: 100 }
  validates :contact_number, presence: true, length: { maximum: 30 }
  validates :address, presence: true, length: { maximum: 255 }
  validates :fb_page_url, presence: true, length: { maximum: 255 }
  validates :budget, presence: true, numericality: { only_integer: true }
  validates :category_id, presence: true
  validates :image, presence: true

  mount_uploader :image, VendorImageUploader

  scope :vendors_with_reviews, lambda { |category_id: nil, subcategory_id: nil, average_review: nil, budget_from: nil, budget_to: nil|
    query = all
    query = query.where(category_id: category_id) unless category_id.nil?
    query = query.where(subcategory_id: subcategory_id) unless subcategory_id.nil?
    unless average_review.nil?
     query = query.where("average_review >= #{average_review}")
    end
    query = query.where("budget >= #{budget_from}") unless budget_from.nil?
    query = query.where("budget <= #{budget_to}") unless budget_to.nil?

    query
  }
end

app/controllers/admin/vendors_controller.rb
module Admin
  class VendorsController < AdminController
    before_action :set_vendor, only: %i[show edit update destroy]

    # GET /vendors
    # GET /vendors.json
    def index
      @vendors = Vendor.all
    end

    # GET /vendors/1
    # GET /vendors/1.json
    def show; end

    # GET /vendors/new
    def new
      @vendor = Vendor.new
    end

    # GET /vendors/1/edit
    def edit; end

    # POST /vendors
    # POST /vendors.json
    def create
      @vendor = Vendor.new(vendor_params)

      respond_to do |format|
        if @vendor.save
          format.html { redirect_to admin_vendor_url(@vendor), notice: 'Vendor was successfully created.' }
          format.json { render :show, status: :created, location: @vendor }
        else
          format.html { render :new }
          format.json { render json: @vendor.errors, status: :unprocessable_entity }
        end
      end
    end

    # PATCH/PUT /vendors/1
    # PATCH/PUT /vendors/1.json
    def update
      respond_to do |format|
        if @vendor.update(vendor_params)
          format.html { redirect_to admin_vendor_url(@vendor), notice: 'Vendor was successfully updated.' }
          format.json { render :show, status: :ok, location: @vendor }
        else
          format.html { render :edit }
          format.json { render json: @vendor.errors, status: :unprocessable_entity }
        end
      end
    end

    # DELETE /vendors/1
    # DELETE /vendors/1.json
    def destroy
      @vendor.destroy
      respond_to do |format|
        format.html { redirect_to admin_vendor_url, notice: 'Vendor was successfully destroyed.' }
        format.json { head :no_content }
      end
    end

    private

    # Use callbacks to share common setup or constraints between actions.
    def set_vendor
      @vendor = Vendor.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def vendor_params
      params.require(:vendor).permit(:title, :contact_number, :address, :budget, :fb_page_url, :image, :category_id, :subcategory_id)
    end
  end
end

app/controllers/api/entities/vendor.rb
module API
  module Entities
    class Vendor < Grape::Entity
      expose :title
      expose :contact_number
      expose :address
      expose :fb_page_url
      expose :portfolios, using: API::Entities::Portfolio
      expose :reviews, using: API::Entities::Review
      expose :average_review
      expose :reviews_count
    end
  end
end

app/controllers/api/entities/vendors.rb
module API
  module Entities
    class Vendors < Grape::Entity
      expose :id
      expose :image_url
      expose :average_review
      expose :reviews_count
    end
  end
end

app/controllers/api/v1/vendors.rb
module API
  module V1
    class Vendors < Grape::API
      include API::V1::Defaults

      resource :vendors do
        desc 'Search vendors'
        params do
          requires :category_id, type: String, desc: "ID of the
            category"
          optional :subcategory_id, type: String, desc: 'Subcategory ID'
          optional :average_review, type: String
          optional :budget_from, type: Integer
          optional :budget_to, type: Integer
        end
        get '', root: :vendors do
          vendors = Vendor.vendors_with_reviews(category_id: permitted_params[:category_id],
                                                subcategory_id: permitted_params[:subcategory_id], average_review: permitted_params[:average_review],
                                                budget_from: permitted_params[:budget_from], budget_to: permitted_params[:budget_to])
          present vendors, with: API::Entities::Vendors
        end

        desc 'Return a vendor'
        params do
          requires :id, type: String, desc: "ID of the
            vendor"
        end
        get ':id', root: 'vendors' do
          vendor = Vendor.where(id: permitted_params[:id]).eager_load(:portfolios).first!

          present vendor, with: API::Entities::Vendor
        end
      end
    end
  end
end

app/helpers/vendors_helper.rb
module VendorsHelper
end

app/views/admin/vendors/_form.html.slim
= form_for [:admin, @vendor] do |f|
  - if @vendor.errors.any?
    #error_explanation
      h2 = "#{pluralize(@vendor.errors.count, "error")} prohibited this vendor from being saved:"
      ul
        - @vendor.errors.full_messages.each do |message|
          li = message

  .field
    = f.label :title
    = f.text_field :title, class: "form-control"
    .field
      = f.label :category_id
      = f.select("category_id", Category.all.collect {|p| [ p.title, p.id ] }, { include_blank: true }, class: "form-control")
    .field
      = f.label :subcategory_id
      = f.select("subcategory_id", Subcategory.all.collect {|p| [ p.title, p.id ] }, { include_blank: true }, class: "form-control")
    .field
      = f.label :image
      = f.file_field :image, class: "form-control"

  .field
    = f.label :contact_number
    = f.text_field :contact_number, class: "form-control"
  .field
    = f.label :budget
    = f.text_field :budget, class: "form-control"
  .field
    = f.label :address
    = f.text_field :address, class: "form-control"
  .field
    = f.label :fb_page_url
    = f.text_field :fb_page_url, class: "form-control"

  .actions
    = f.submit "Submit", :class => "btn btn-primary"

app/views/admin/vendors/edit.html.slim
h1 Editing vendor

== render 'form'

=> link_to 'Show', admin_vendor_path(@vendor)
'|
=< link_to 'Back', admin_vendors_path

app/views/admin/vendors/index.html.slim
section.content-header
  h1 Manage Vendors

section.content
  div.box
    div.box-header.with-border
      h3.box-title List

    div.box-body
      table.table.table-bordered.table-hover
        thead
          tr
            th Title
            th style="width:10em" Contact Number
            th style="width:10em" Budget
            th colspan="3"
        tbody
          - @vendors.each do |vendor|
            tr
              td
                = vendor.title
              td
                = vendor.contact_number
              td
                = "#{vendor.budget} LE"
              td style="width:7em"
                = fa_icon "eye"
                = link_to "View", admin_vendor_path(vendor)
              td style="width:7em"
                = fa_icon "pencil"
                = link_to "Edit", edit_admin_vendor_path(vendor)
              td style="with:7em"
                = fa_icon "remove"
                = link_to "Delete", admin_vendor_path(vendor), method: :delete, data: { confirm: "This record will be deleted. Are you sure?" }
      br
      = link_to 'New Vendor', new_admin_vendor_path, { class: "btn btn-default" }

app/views/admin/vendors/new.html.slim
h1 New vendor

== render 'form'

= link_to 'Back', admin_vendors_path

app/views/admin/vendors/show.html.slim
p#notice = notice

p
  strong Title:
  = @vendor.title
p
  strong Contact Number:
  = @vendor.contact_number

=> link_to 'Edit', edit_admin_vendor_path(@vendor)
'|
=< link_to 'Back', admin_vendors_path